#ifndef	___RENDERER_H___
#define	___RENDERER_H___

#include "common.h"

#include <GLES2/gl2.h>
#include <GLES2/gl2ext.h>


namespace sys
{

/************************
    シェーダプログラム
 ************************/
struct ShaderProgram
{
	GLuint	program;			// プログラムオブジェクト
	GLint	position;			// 座標
	GLint	color;				// カラー
	GLuint	projection;			// 透視変換

		ShaderProgram(void)					// コンストラクタ
		{
			program = 0;
		}
		~ShaderProgram()					// デストラクタ
		{
			quit();
		}
	void	init(GLuint, GLuint);			// 初期化
	void	use(const GLfloat*);			// 使用
	void	quit(void);						// 終了
};

/**************
    描画管理
 **************/
class Renderer
{
private :

	static void		initShader(void);					// シェーダ初期化
	static GLuint	loadShader(GLenum, const char*);	// シェーダ作成

public :

	static ShaderProgram*	shader;						// シェーダプログラム
	static float			mat_projection[4*4];		// 透視変換行列

	static void		init(int, int);						// 初期化
	static void		quit(void);							// 終了
	static void		update(void);						// 稼働（前処理）
	static void		draw(void);							// 描画（後処理）
	static ShaderProgram*	use_shader(void);			// シェーダ使用
};

}

#endif
/********************* End of File ********************************/
