
#include "common.h"
#include "Renderer.h"


using namespace sys;


extern "C"
{
JNIEXPORT void JNICALL		Java_sys_BaseActivity_initNative(JNIEnv*, jobject, jint, jint);
JNIEXPORT jboolean JNICALL	Java_sys_BaseActivity_updateNative(JNIEnv*, jobject);
}

void	init_app(void);			// メイン初期化
Bool	update_app(void);		// メイン稼働

/************
    初期化
 ************/
JNIEXPORT void JNICALL	Java_sys_BaseActivity_initNative(JNIEnv* env, jobject, jint width, jint height)
{
	LOGI("initNative (%d, %d)", width, height);

	Renderer::init(width, height);				// 描画管理初期化

	init_app();									// アプリメイン初期化
}

/**********
    稼働
 **********/
JNIEXPORT jboolean JNICALL	Java_sys_BaseActivity_updateNative(JNIEnv*, jobject)
{
	Renderer::update();							// 描画管理稼働

	if ( update_app() ) {						// アプリメイン稼働
		return	JNI_TRUE;
	}
	return	JNI_FALSE;							// アプリ終了
}

/**************** End of File *************************************************/